(document:surround "/std/base")

;; write down all settings via backend
(define (apply-to-backend url)
  (changed? state #f)
  (woo-write url
    'chkconfig_status (chkconfig-status state)
    'change_status (change-status value)))

;; reset all settings using data from backend
(define (reset-from-backend url)
  (changed? state #f)
  (let ((data (woo-read-first url)))
    (service-name     text  (bold (woo-get-option data 'name "")))
    (service-desc     text  (woo-get-option data 'description ""))
    (service-status   text  (string-append (bold (_ "Current state:" )) " " (woo-get-option data 'status "")))
    (chkconfig-status state (woo-get-option data 'chkconfig_status ""))

    (change-status enumref url)
    (change-status current 0)))
;;;

(define (selected-object) (services-object-list-id value))

(define (url-of-obj obj)
  (string-append "/services/" obj))


(define (apply-and-reset backend)
 (apply-to-backend backend)
 (reset-from-backend backend))


;; making widgets

(gridbox columns "30;70"
  (document:id services-object-list-id
    (listbox enumref "/services" header (vector (_ "Services"))
      current 0
      (when selected
        (if (changed? state)
          (if (eq? 'yes (document:popup-question (_"There are unsaved changes in the service settings. Do you want to apply these changes?") 'yes 'no))
            (apply-and-reset (url-of-obj (old-obj value)))
            (reset-from-backend (url-of-obj (old-obj value)))))

        (reset-from-backend (url-of-obj (selected-object)))
        (old-obj value (selected-object))
      )))

  (groupbox ""
    (document:id service-name   (label "" ))
    (document:id service-desc   (textbox "" alterability #f))
    (document:id service-status (label ""))
    (gridbox columns "10;90"
      (label (bold (_ "Change state:")))
      (document:id change-status (combobox align "left"
        (when selected (changed? state #t)))))

    (gridbox columns "40;30;30"

      (document:id chkconfig-status (checkbox (_ "Start on boot")
        (when toggled (changed? state #t))))
      (button (_ "Apply") (when clicked (apply-and-reset (url-of-obj (selected-object)))))
      (button (_ "Reset") (when clicked (reset-from-backend (url-of-obj (selected-object))))))))

(document:id changed? (checkbox "" visibility #f))
(document:id old-obj  (edit "" visibility #f))
(old-obj value (selected-object))

(reset-from-backend (url-of-obj (selected-object)))

